#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include "/musr/macros/macros.h"
#import <objc/objc.h>
#import "/musr/objc/Comb.h"
#import "/musr/objc/Allpass.h"
#define MAXCOMBS 16
struct combdata {
	float loopt;
	float rvt;
	} comblist[MAXCOMBS];
struct allpassdata {
	float loopt;
	float rvt;
	} allpasslist[MAXCOMBS];
int nAllpasses = 0;
int nCombs=0;
float allpassLoc[MAXCOMBS];
float combLoc[MAXCOMBS];

extern SFHEADER sfdesc[NFILES];

double reverbit(p,n_args)
float *p;
{
	int nchansout,nchansin,nsamps,input,output,i,j;
	float out[4],xin[4],sig,newsig,sigl,sigr;
	id myComb[MAXCOMBS],myAllpass[MAXCOMBS];
	/* start,dur,inskip,rvt,lpt1,lpt2....lptn */

	input=0; output=1;
	nchansin = sfchans(&sfdesc[0]);
	nchansout = sfchans(&sfdesc[1]);
	if(nchansout != 2) {
		printf("output file must be stereo!\n");
		closesf();
		}
	nsamps=setnote(p[0],p[1],output);
	setnote(p[2],p[1],input);
	i=0;
	for(i=0; i<nCombs; i++) {
		myComb[i] = [Comb create];
		[myComb[i] 
		     loopt:comblist[i].loopt sRate:SR revTime:comblist[i].rvt];
		if(comblist[i].rvt < 0.) [myComb[i] gain:-comblist[i].rvt];			}
	for(i=0; i<nAllpasses; i++) {
		myAllpass[i] = [Allpass create];
		[myAllpass[i] loopt:allpasslist[i].loopt sRate:SR revTime:allpasslist[i].rvt];
		if(allpasslist[i].rvt < 0.) [myAllpass[i] gain:-allpasslist[i].rvt];
			}

	for(i=0; i<nsamps; i++) {
		if(!GETIN(xin,input)) break;
		out[0]=out[1]=sig=sigl=sigr=0;
		for(j=0; j<nCombs; j++)	{
			if(nchansin == 2)
				newsig = xin[0] * combLoc[j] + xin[1] * (1.-combLoc[j]);
			else
				newsig = xin[0];
			newsig += [myComb[j] bang:newsig];
			sigl += newsig * combLoc[j];
			sigr += newsig * (1.-combLoc[j]);
			}
					
		for(j=0; j<nAllpasses; j++) {
			if(nchansin == 2)
			newsig = 
                          xin[0] * allpassLoc[j] + xin[1] * (1.-allpassLoc[j]);
			else newsig = xin[0];
			newsig = [myAllpass[j] bang:newsig];
			out[0] += newsig * allpassLoc[j];
			out[1] += newsig * (1.-allpassLoc[j]);
		}
			
		out[0] += sigl;
		out[1] += sigr;
		ADDOUT(out,output);
	}
	nsamps = p[3] * SR;
	for(i=0; i<nsamps; i++) {
		out[0]=out[1]=sig=sigl=sigr=0;
		for(j=0; j<nCombs; j++)	{		
			sig += [myComb[j] bang:0.];
			sigl += sig * combLoc[j];
			sigr += sig * (1.-combLoc[j]);
		}
		for(j=out[0]=out[1]=0; j<nAllpasses; j++) {
			sig = [myAllpass[j] bang:sig];
		/*
		 * distribute allpasses across stereo field
		 */
			out[0] += sig * allpassLoc[j];
			out[1] += sig * (1.-allpassLoc[j]);
		}
		out[0] += sigl;
		out[1] += sigr;
		ADDOUT(out,output);
	}
	endnote(output);
	for(i=0; i<nCombs; i++) [myComb[i] freeup]; 
	for(i=0; i<nAllpasses; i++) [myAllpass[i] freeup];
}

double combbank(p,n_args)
float *p;
{
	int i;
	for(i=0,nCombs=0; i<n_args; i +=2,nCombs++) {
		comblist[nCombs].loopt = 1./p[i];
		comblist[nCombs].rvt = p[i+1];
	}
	for(i=0; i<nCombs; i++) {
		combLoc[i] = (i + 1.0) * (1.0 / (nCombs + 1));
		printf("%f  %f, loc=%g\n",
		comblist[i].loopt, comblist[i].rvt, combLoc[i]);
	}


}

double allpassbank(p,n_args)
float *p;
{
	int i;
	for(i=0,nAllpasses=0; i<n_args; i +=2,nAllpasses++) {
		allpasslist[nAllpasses].loopt =  1./p[i];
		allpasslist[nAllpasses].rvt = p[i+1];
		}
	for(i=0; i<nAllpasses; i++) {
		allpassLoc[i] = (i + 1.0) * (1.0 / (nAllpasses + 1));
		printf("%f  %f, loc=%g\n",
		allpasslist[i].loopt, allpasslist[i].rvt, allpassLoc[i]);
	}
}

int NBYTES = 32768;

profile()
{  
	UG_INTRO("reverbit",reverbit); 
	UG_INTRO("combbank",combbank);
	UG_INTRO("allpassbank",allpassbank);
}
